searchData={"items":[{"type":"module","title":"Zephyr","doc":"Documentation for `Zephyr`.","ref":"Zephyr.html"},{"type":"function","title":"Zephyr.check/4","doc":"Checks if the given subject has access to the given object based on the given relation","ref":"Zephyr.html#check/4"},{"type":"function","title":"Zephyr.read/3","doc":"List subjects who has relation to the object","ref":"Zephyr.html#read/3"},{"type":"function","title":"Zephyr.write/3","doc":"Inserts a new relation between the given subject and object","ref":"Zephyr.html#write/3"},{"type":"function","title":"Zephyr.write!/3","doc":"Similar to write/2 but raises an error if the relation could not be inserted","ref":"Zephyr.html#write!/3"},{"type":"type","title":"Zephyr.object/0","doc":"","ref":"Zephyr.html#t:object/0"},{"type":"type","title":"Zephyr.subject/0","doc":"","ref":"Zephyr.html#t:subject/0"},{"type":"module","title":"Zephyr.Definition","doc":"","ref":"Zephyr.Definition.html"},{"type":"macro","title":"Zephyr.Definition.definition/1","doc":"","ref":"Zephyr.Definition.html#definition/1"},{"type":"macro","title":"Zephyr.Definition.definition/2","doc":"Macro for defining an object. An object represents instances of resources or subjects\nin the system.\n\nExample in your `my_app/lib/my_app/definitions.ex` file you may write:\n```\nimport Zephyr.Definition\n\ndefinition(:users)\n\ndefinition :organizations do\n  relation(:member, :users)\nend\n```","ref":"Zephyr.Definition.html#definition/2"},{"type":"macro","title":"Zephyr.Definition.relation/2","doc":"","ref":"Zephyr.Definition.html#relation/2"},{"type":"behaviour","title":"Zephyr.Migrations","doc":"API for calling up and down in Ecto migrations","ref":"Zephyr.Migrations.html"},{"type":"function","title":"Zephyr.Migrations.down/1","doc":"","ref":"Zephyr.Migrations.html#down/1"},{"type":"callback","title":"Zephyr.Migrations.down/1","doc":"Migrates storage down to the previous version.","ref":"Zephyr.Migrations.html#c:down/1"},{"type":"function","title":"Zephyr.Migrations.up/1","doc":"","ref":"Zephyr.Migrations.html#up/1"},{"type":"callback","title":"Zephyr.Migrations.up/1","doc":"Migrates storage up to the latest version.","ref":"Zephyr.Migrations.html#c:up/1"},{"type":"module","title":"Zephyr.Operations","doc":"Represents the operations that can be performed between relations.\nUnion, intersection, exclusion, and arrow are among the supported operations","ref":"Zephyr.Operations.html"},{"type":"function","title":"Zephyr.Operations.&&/2","doc":"Intersection operator","ref":"Zephyr.Operations.html#&&/2"},{"type":"function","title":"Zephyr.Operations.+/2","doc":"Union operator","ref":"Zephyr.Operations.html#+/2"},{"type":"function","title":"Zephyr.Operations.-/2","doc":"Exclusion operator","ref":"Zephyr.Operations.html#-/2"},{"type":"function","title":"Zephyr.Operations.>/2","doc":"Arrow operator","ref":"Zephyr.Operations.html#%3E/2"},{"type":"module","title":"Zephyr.QueryBuilder","doc":"Traverse the resolved relations and build the query.","ref":"Zephyr.QueryBuilder.html"},{"type":"function","title":"Zephyr.QueryBuilder.build_query/2","doc":"","ref":"Zephyr.QueryBuilder.html#build_query/2"},{"type":"function","title":"Zephyr.QueryBuilder.read_query/2","doc":"","ref":"Zephyr.QueryBuilder.html#read_query/2"},{"type":"module","title":"Zephyr.RelationResolver","doc":"Traverse the AST and resolve relations to their respective modules.","ref":"Zephyr.RelationResolver.html"},{"type":"function","title":"Zephyr.RelationResolver.resolve_relation/2","doc":"","ref":"Zephyr.RelationResolver.html#resolve_relation/2"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}